package com.hive.bee.entity;

import lombok.*;

import java.io.Serializable;
import java.time.LocalDateTime;

import com.baomidou.mybatisplus.annotation.*;

/**
 * 蜂箱 DO
 *
 * @author 芋道源码
 */
@TableName("bee_hive")
@KeySequence("bee_hive_seq") // 用于 Oracle、PostgreSQL、Kingbase、DB2、H2 数据库的主键自增。如果是 MySQL 等数据库，可不写。
@Data
@ToString(callSuper = true)
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class BeeHive implements Serializable {
    private static long serialVersionUID = 1L;

    /**
     * 主键
     */
    @TableId
    private Long id;
    /**
     * 蜂场id
     *
     * 枚举 {@link TODO mf_type 对应的类}
     */
    private Long peakFieldId;
    /**
     * 蜂箱编号
     */
    private String beeHiveNumber;
    /**
     * 蜂箱名称
     */
    private String beeHiveName;
    /**
     * mac号
     */
    private String beeHiveMac;
    /**
     * 蜂箱位置
     */
    private String beeHivePosition;
    /**
     * 最后在线时间
     */
    private LocalDateTime lastOnlineTime;
    /**
     * 在线状态
     */
    private Integer onlineType;
    /**
     * 蜂箱重量
     */
    private String beeHiveWeight;
    /**
     * 当前温度
     */
    private String currentTemperature;
    /**
     * 当前湿度
     */
    private String currentHumidity;
    /**
     * 当前噪音
     */
    private String currentNoise;
    /**
     * 是否删除
     */
    private boolean deleted;
    /**
     * 设备di
     */
    private String deviceId;
    /**
     * 蜜蜂数量
     */
    private String currentNumber;
    /**
     * 电量
     */
    private String electricQuantity;

    /**
     *  数据上传时间
     */
    private LocalDateTime dateUploadTime;

}