package com.hive.bee.entity;

import lombok.*;

import java.io.Serializable;
import java.time.LocalDateTime;

import com.baomidou.mybatisplus.annotation.*;

/**
 * 蜂箱日志 DO
 *
 * @author 智能蜂箱
 */
@TableName("bee_hive_log")
@KeySequence("bee_hive_log_seq") // 用于 Oracle、PostgreSQL、Kingbase、DB2、H2 数据库的主键自增。如果是 MySQL 等数据库，可不写。
@Data
@ToString(callSuper = true)
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class BeeHiveLog implements Serializable {
    private static long serialVersionUID = 1L;
    /**
     * 主键
     */
    @TableId
    private Long id;
    /**
     * 蜂场id
     */
    private Long peakFieldId;
    /**
     * 蜂箱编号
     */
    private String beeHiveNumber;
    /**
     * 蜂箱名称
     */
    private String beeHiveName;
    /**
     * 重量
     */
    private String beeHiveWeight;
    /**
     * 温度
     */
    private String currentTemperature;
    /**
     * 湿度
     */
    private String currentHumidity;
    /**
     * 噪音
     */
    private String currentNoise;
    /**
     * 是否删除
     */
    private boolean deleted;
    /**
     * 蜂箱id
     */
    private long beeHiveId;

    /**
     *  数据上传时间
     */
    private LocalDateTime dateUploadTime;
}