package com.hive.communication.netty.server;

import com.hive.config.netty.NettyConfig;
import io.netty.channel.Channel;
import io.netty.channel.ChannelFuture;

/**
 * @Author: HIVE - LGH
 * @Date: 2024/10/11 15:28
 * @Version: V1.0
 */
public class ChannelManager {

    // 添加Channel到group和map中
    public static void addChannel(Channel channel, String deviceId) {
        NettyConfig.group.add(channel);
        NettyConfig.portToChannelMap.put(deviceId, channel);
    }
    // 从group和map中移除Channel
    public static void removeChannel(Channel channel) {
        NettyConfig.group.remove(channel);
        NettyConfig.portToChannelMap.values().removeIf(c -> c.equals(channel));
    }
    // 关闭指定端口的Channel
    public static void closeChannelByPort(int port) {
        Channel channel = NettyConfig.portToChannelMap.get(port);
        System.out.println(channel.isOpen());
        if (channel != null && channel.isOpen()) {
            ChannelFuture future = channel.close();
            future.addListener(f -> {
                if (f.isSuccess()) {
                    NettyConfig.portToChannelMap.remove(port);
                }
            });
        }
    }
    // 关闭所有Channel
    public static void closeAllChannels() {
        NettyConfig.group.close().syncUninterruptibly();
        NettyConfig.portToChannelMap.clear();
    }
}
