package com.hive.communication.netty.server.dataprocessing;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.hive.bee.entity.BeeHive;
import com.hive.bee.entity.BeeHiveLog;
import com.hive.bee.service.HiveLogService;
import com.hive.bee.service.HiveService;
import com.hive.bee.vo.BeeHiveVo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import static com.hive.util.ConverterUtil.copySameFields;

@Slf4j
@Component
public class BeeHiveAdd {
    @Autowired
    private HiveService hiveService;
    @Autowired
    private HiveLogService hiveLogService;
    public void addAndEdit(BeeHive beeHive){
        hiveService.updateById(beeHive);
        BeeHiveLog beeHiveLog = new BeeHiveLog();
        BeeHiveVo beeHiveVo = new BeeHiveVo();
        //用来去除不需要的字段
        copySameFields(beeHive, beeHiveVo);
        copySameFields(beeHiveVo, beeHiveLog);
        beeHiveLog.setBeeHiveId(beeHive.getId());
        hiveLogService.save(beeHiveLog);
    }
    public BeeHive getOneBeeHive(String deviceId){
        QueryWrapper<BeeHive> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BeeHive::isDeleted,0).eq(BeeHive::getDeviceId,deviceId);
        return hiveService.getOne(queryWrapper);
    }
}
