package com.hive.communication.util;

public class CheckCode {

    // 计算字符串的校验码（异位校验)
    public static int calculateParity(String input, boolean oddParity) {
        int parity = 0;
        for (char ch : input.toCharArray()) {
            parity ^= ch;
        }
        // 根据需要调整奇偶校验位
        int parityBit = Integer.bitCount(parity) % 2;
        if (oddParity) {
            parityBit = parityBit == 0 ? 1 : 0; // 奇校验：如果0变成1，如果1变成0
        }
        return parityBit;
    }
    // 计算16进制字符串的校验码
    public static int calculateChecksum(String hexString) {
        int sum = 0;

        // 每两个字符作为一个16进制数进行解析
        for (int i = 0; i < hexString.length(); i += 2) {
            String hexPair = hexString.substring(i, i + 2);
            int hexValue = Integer.parseInt(hexPair, 16);
            sum += hexValue;
        }

        // 保留最后8位
        int checksum = sum & 0xFF; // 0xFF表示8位全1的掩码

        return checksum;
    }

}
