package com.hive.communication.util;

import java.math.BigDecimal;
import java.math.BigInteger;
/**
 * 进制转换
 */
public class HexConversion {


    /**
     * 十六进制单精度浮点数，转BigDecimal，保留2为小数，截掉多余小数位
     * @param hex
     * @return
     */
    public static BigDecimal hexFloat2BigDecimal(String hex) {
        float value = Float.intBitsToFloat((int) Long.parseLong(hex, 16));
        BigDecimal bd = new BigDecimal(Float.toString(value));
        return bd.setScale(2, BigDecimal.ROUND_DOWN);
    }
    /**
     * 该方法主要使用正则表达式来判断字符串中是否包含字母
     * @param cardNum 待检验的原始卡号
     * @return 返回是否包含
     */
    public static boolean judgeContainsStr(String cardNum) {

        //  String regex1 = ".*[a-zA-z].*";

        String regex=".*[a-zA-z].*";
        return cardNum.matches(regex);
    }

    /**
     * 十六进制双精度浮点数，转BigDecimal，保留2为小数，截掉多余小数位
     * @param hex
     * @return
     */
    public static BigDecimal hexDouble2BigDecimal2(String hex) {
        double value = Double.longBitsToDouble(Long.valueOf(hex,16).longValue());
        BigDecimal bd = BigDecimal.valueOf(value);
        return bd.setScale(2, BigDecimal.ROUND_DOWN);
    }
    /**
     * 十六进制转十进制(只支持正数)
     * @param hex
     * @return Integer
     */
    public static Integer hexToBigInt(String hex){
       return new BigInteger(hex,16).intValue();
    }

    /**
     * 十六进制转十进制(只支持正数)
     * @param hex
     * @return long
     */
    public static long hexToBigLong(String hex){
        return Long.parseLong(hex, 16);
    }


    /**
     * hex 转为数组
     * @param s
     * @return String
     */
    public static byte[] hexStringToByteArray(String s) {
        int len = s.length();
        byte[] data = new byte[len / 2];
        for (int i = 0; i < len; i += 2) {
            data[i / 2] = (byte) ((Character.digit(s.charAt(i), 16) << 4)
                    + Character.digit(s.charAt(i+1), 16));
        }
        return data;
    }
    /**
     * 十六进制转十进制(负数也可以转)
     * @param hexadecimalStr
     * @return String
     */
    public static int hexadecimal16Conversion(String hexadecimalStr) {
        int getDataDecimal = 0;//转化得到的目标数据
//16进制代表数据 4位数字
        if (hexadecimalStr.length() == 4) {
            int bit1Num = Integer.parseInt(hexadecimalStr.substring(0, 1), 16);//获取第一位。判断是正数还是负数
            if (bit1Num < 8) { //小于8是正数
                getDataDecimal = Integer.parseInt(hexadecimalStr, 16);
            } else { //负数
                hexadecimalStr = "FFFF" + hexadecimalStr; //先不全八位
                getDataDecimal = new BigInteger(hexadecimalStr, 16).intValue();
            }
            return getDataDecimal;
        }
        return 0;
    }
}
